{# -------------------  Вывод примера в виде json -----------------------------------------------#}
{% macro jsonExample(example) %}
{{ '```json' }}
{{ example|json_encode(constant('JSON_PRETTY_PRINT') b-or constant('JSON_UNESCAPED_UNICODE'))|raw }}
{{ '```    ' }}
{% endmacro %}

{# -------------------  Подробное описание параметра/свойства -----------------------------------#}
{% macro itemDesc(items) %}
{%- for item in items -%}
<a name="{{ item.name }}"></a>
{{ '`' ~ item.name ~ '` - **' ~ item.short_name|raw ~ '**  '}}
{% if item.full_description|length %}
{{ item.full_description }}
{% endif %}
{% if item.optional_description|length %}
{{ '`*` - ' ~ item.optional_description ~ '  '}}
{% endif %}
{% if item.enum is defined %}
{{ 'Список возможных значений: '  }}
{% for value in item.enum %}
{{ '`' ~ value ~ '`'}}{% if not loop.last %}{{ ',' }}{% endif %}{% endfor %}{{ '  ' }}
{% endif %}
{% if item.items.enum is defined %}
{{ 'Список возможных значений для элемента массива: '  }}
{% for value in item.items.enum %}
{{ '`' ~ value ~ '`'}}{% if not loop.last %}{{ ',' }}{% endif %}{% endfor %}{{ '  ' }}
{% endif %}
{% if item.default|length %}
{{ 'Значение по умолчанию: `' ~ item.default ~ '`  '}}
{% endif %}
{% if item.maxLength|length %}
{{ 'Максимальное кол-во символов:'  }}{{ '`' ~ item.maxLength ~ '`'}}
{% endif %}
{% if item.minLength|length %}{{ 'Минимальное кол-во символов: `' ~ item.minLength ~ '`  '}}
{% endif %}
{% if item.formExample|length %}
{{ 'Пример:  ' }}
{{ _self.jsonExample(item.formExample) }}
{% endif %}
{% if loop.last == false %}

{% endif %}
{%- endfor -%}
{% endmacro %}

{# -------------------  Рекурсивный вывод списка моделей ----------------------------------------#}
{% macro reqOutput(namespace, elements, indent) %}
{{ indent ~ '* **' ~ namespace ~ '**'}}
{% for key, childModels in elements %}
{% if key == 'models' %}
{% if childModels is defined %}
{% for model in childModels %}
{% if model.title is defined and model.readmeFile is defined %}
{{ indent ~ '  * [' ~ model.title ~ '](' ~ model.readmeFile ~ ')'}}
{% endif %}
{% endfor %}
{% endif %}
{% else %}
{{- _self.reqOutput(key, childModels, indent ~ '  ') }}
{% endif %}
{% endfor %}
{% endmacro %}

